QuantLib: CubicInterpolation Class Reference

A free/open-source library for quantitative finance Reference manual - version 1.6

- Main Page
- Related Pages
- Modules
- Classes
- Examples

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | List of all members
CubicInterpolation Class Reference

Cubic interpolation between discrete points. More...

`#include <ql/math/interpolations/cubicinterpolation.hpp>`

Inheritance diagram for CubicInterpolation:
[legend]

## Public Types
enum | DerivativeApprox { Spline, SplineOM1, SplineOM2, FourthOrder, Parabolic, FritschButland, Akima, Kruger }
enum | BoundaryCondition { NotAKnot, FirstDerivative, SecondDerivative, Periodic, Lagrange }
Public Types inherited from Interpolation
typedef Real | argument_type
typedef Real | result_type

## Public Member Functions
template<class I1 , class I2 >
| CubicInterpolation (const I1 &xBegin, const I1 &xEnd, const I2 &yBegin, CubicInterpolation::DerivativeApprox da, bool monotonic, CubicInterpolation::BoundaryCondition leftCond, Real leftConditionValue, CubicInterpolation::BoundaryCondition rightCond, Real rightConditionValue)
const std::vector< Real > & | primitiveConstants () const
const std::vector< Real > & | aCoefficients () const
const std::vector< Real > & | bCoefficients () const
const std::vector< Real > & | cCoefficients () const
const std::vector< bool > & | monotonicityAdjustments () const
Public Member Functions inherited from Interpolation
bool | empty () const
Real | operator() (Real x, bool allowExtrapolation=false) const
Real | primitive (Real x, bool allowExtrapolation=false) const
Real | derivative (Real x, bool allowExtrapolation=false) const
Real | secondDerivative (Real x, bool allowExtrapolation=false) const
Real | xMin () const
Real | xMax () const
bool | isInRange (Real x) const
void | update ()
Public Member Functions inherited from Extrapolator
void | enableExtrapolation (bool b=true)
| enable extrapolation in subsequent calls
void | disableExtrapolation (bool b=true)
| disable extrapolation in subsequent calls
bool | allowsExtrapolation () const
| tells whether extrapolation is enabled

## Additional Inherited Members
Protected Member Functions inherited from Interpolation
void | checkRange (Real x, bool extrapolate) const
Protected Attributes inherited from Interpolation
boost::shared_ptr< Impl > | impl_

## Detailed Description

Cubic interpolation between discrete points.

Cubic interpolation is fully defined when the ${f_i}$ function values at points ${x_i}$ are supplemented with ${f^'_i}$ function derivative values.

Different type of first derivative approximations are implemented, both local and non-local. Local schemes (Fourth-order, Parabolic, Modified Parabolic, Fritsch-Butland, Akima, Kruger) use only $f$ values near $x_i$ to calculate each $f^'_i$. Non-local schemes (Spline with different boundary conditions) use all ${f_i}$ values and obtain ${f^'_i}$ by solving a linear system of equations. Local schemes produce $C^1$ interpolants, while the spline schemes generate $C^2$ interpolants.

Hyman's monotonicity constraint filter is also implemented: it can be applied to all schemes to ensure that in the regions of local monotoniticity of the input (three successive increasing or decreasing values) the interpolating cubic remains monotonic. If the interpolating cubic is already monotonic, the Hyman filter leaves it unchanged preserving all its original features.

In the case of $C^2$ interpolants the Hyman filter ensures local monotonicity at the expense of the second derivative of the interpolant which will no longer be continuous in the points where the filter has been applied.

While some non-linear schemes (Modified Parabolic, Fritsch-Butland, Kruger) are guaranteed to be locally monotonic in their original approximation, all other schemes must be filtered according to the Hyman criteria at the expense of their linearity.

See R. L. Dougherty, A. Edelman, and J. M. Hyman, "Nonnegativity-, Monotonicity-, or Convexity-Preserving CubicSpline and Quintic Hermite Interpolation" Mathematics Of Computation, v. 52, n. 186, April 1989, pp. 471-494.

Tests:
  to be adapted from old ones.

## Member Enumeration Documentation

enum DerivativeApprox

Enumerator
Spline | Spline approximation (non-local, non-monotonic, linear[?]). Different boundary conditions can be used on the left and right boundaries: see BoundaryCondition.
SplineOM1 | Overshooting minimization 1st derivative.
SplineOM2 | Overshooting minimization 2nd derivative.
FourthOrder | Fourth-order approximation (local, non-monotonic, linear)
Parabolic | Parabolic approximation (local, non-monotonic, linear)
FritschButland | Fritsch-Butland approximation (local, monotonic, non-linear)
Akima | Akima approximation (local, non-monotonic, non-linear)
Kruger | Kruger approximation (local, monotonic, non-linear)

enum BoundaryCondition

Enumerator
NotAKnot | Make second(-last) point an inactive knot.
FirstDerivative | Match value of end-slope.
SecondDerivative | Match value of second derivative at end.
Periodic | Match first and second derivative at either end.
Lagrange | Match end-slope to the slope of the cubic that matches the first four data at the respective end

## Constructor & Destructor Documentation

CubicInterpolation | ( | const I1 & | xBegin,
|  | const I1 & | xEnd,
|  | const I2 & | yBegin,
|  | CubicInterpolation::DerivativeApprox | da,
|  | bool | monotonic,
|  | CubicInterpolation::BoundaryCondition | leftCond,
|  | Real | leftConditionValue,
|  | CubicInterpolation::BoundaryCondition | rightCond,
|  | Real | rightConditionValue
| ) |  |

Precondition
  the \( x \) values must be sorted.